package ru.dbotthepony.mc.otm.player

import net.minecraft.world.item.Item
import ru.dbotthepony.mc.otm.container.EnhancedContainer
import ru.dbotthepony.mc.otm.container.IContainerSlot
import ru.dbotthepony.mc.otm.container.IEnhancedContainer

class ExopackContainer(size: Int, val player: MatteryPlayer) : EnhancedContainer<IPlayerInventorySlot>(size) {
	private inner class Slot(slot: Int) : IContainerSlot.Simple(slot, this@ExopackContainer), IPlayerInventorySlot {
		override var shouldCharge: Boolean
			get() = (PlayerInventoryWrapper.SLOTS + slot) in player.slotsChargeFlag
			set(value) { if (value) player.slotsChargeFlag.add(PlayerInventoryWrapper.SLOTS + slot) else player.slotsChargeFlag.remove(PlayerInventoryWrapper.SLOTS + slot) }

		override var filter: Item?
			get() = player.slotFilters[PlayerInventoryWrapper.SLOTS + slot]
			set(value) { if (value == null) player.slotFilters.remove(PlayerInventoryWrapper.SLOTS + slot) else player.slotFilters[PlayerInventoryWrapper.SLOTS + slot] = value }
	}

	override fun containerSlot(slot: Int): IPlayerInventorySlot {
		return Slot(slot)
	}
}
